***User Support:***


For user questions please look for answers and ask first in the [GATK forum](https://gatk.broadinstitute.org/hc/en-us/community/topics).


----


[![Coverage Status](https://coveralls.io/repos/github/broadinstitute/picard/badge.svg?branch=master)](https://coveralls.io/github/broadinstitute/picard?branch=master)
[![Build Status](https://travis-ci.com/broadinstitute/picard.svg?branch=master)](https://travis-ci.com/broadinstitute/picard)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://github.com/broadinstitute/picard/blob/master/LICENSE.txt)

A set of Java command line tools for manipulating high-throughput sequencing (HTS) data and formats.  

Picard is implemented using the HTSJDK Java library [HTSJDK][1] to support
accessing file formats that are commonly used for high-throughput
sequencing data such as [SAM][2] and [VCF][3].  

Picard now builds and passes tests under Java 11. This should be considered to be a *Beta* feature. 
As of version 2.0.1 (Nov. 2015) Picard requires Java 1.8 (jdk8u66). The last version to support Java 1.7 was release 1.141.

#### Building Picard

* First, clone the repo:
```
    git clone https://github.com/broadinstitute/picard.git
    cd picard/
```

* Picard is now built using [gradle](https://gradle.org/). A wrapper script (`gradlew`) is included which will download the appropriate version of gradle on the first invocation.
    
* To build a fully-packaged, runnable Picard jar with all dependencies included, run:
```
    ./gradlew shadowJar
```

* The resulting jar will be in `build/libs`. To run it, the command is:
```
    java -jar build/libs/picard.jar
    
    or
    
    java -jar build/libs/picard-<VERSION>-all.jar 
```    

    
* To build a jar containing only Picard classes (without its dependencies), run:
```
    ./gradlew jar
```    
    
* To clean the build directory, run:
```
    ./gradlew clean
```

#### Running Tests

* To run all tests, the command is:
```
    ./gradlew test
```

* To run a specific test, the command is:
```
    ./gradlew legacyTest --tests "*TestClassName*"
    
    or
    
    ./gradlew barclayTest --tests "*TestClassName*"
```
Running `legacyTest` uses the legacy commandline parser while `barclayTest` uses the new parser.  



#### Changing the released version of HTSJDK that Picard depends on

To switch Picard's HTSJDK dependency to a different released version:

* Open `build.gradle`
* Edit VERSION in the following line to be a different released version of HTSJDK. HTSJDK releases are listed [here](https://github.com/samtools/htsjdk/releases)
```
    final htsjdkVersion = System.getProperty('htsjdk.version', 'VERSION')`
```
* Open a pull request with this change

#### Building Picard with a Custom Version of HTSJDK

During development in Picard, it is sometimes necessary to build locally against an unreleased version or branch of HTSJDK. 

* To build against an unreleased version of HTSJDK's master branch:
    * Go to the [Broad artifactory](https://artifactory.broadinstitute.org/artifactory/simple/libs-snapshot-local/com/github/samtools/htsjdk/), where continuous snapshots of HTSJDK's master branch are published, and select the version you want to use. For example, `2.5.1-9-g5740ca1-SNAPSHOT`. You can search by tag or short git commit hash.
    * In your Picard clone, run `./gradlew shadowJar -Dhtsjdk.version=VERSION`, where VERSION is the version of the HTSJDK master branch snapshot you want to use.
    
* To build against a version of HTSJDK that has *not* yet been merged into HTSJDK's master branch:
    * Clone [HTSJDK](https://github.com/samtools/htsjdk/), and in your clone check out the tag or branch you want to build Picard with.
    * Run `./gradlew install printVersion` in your htsjdk clone to install that version to your local maven repository. Take note of the version number that gets printed at the end.
    * Switch back to your Picard clone, and run `./gradlew shadowJar -Dhtsjdk.version=VERSION`, where VERSION is the version of HTSJDK you installed to your local maven repository.

#### Releasing Picard

Full instructions on how to create a new release of 
Picard are [here](https://github.com/broadinstitute/picard/wiki/How-to-release-Picard)

#### Path providers

Picard has limited support for reading from Path providers. 
Currently only google's api is supported, and only a few tools support this.
To run with this support you need to compile the cloudJar target with gradle:
```bash
./gradlew cloudJar

```
then run picard as follows:

```bash
java -jar build/lib/picardcloud.jar <Picard arguments starting from program>
```
For example:

```bash 
java -jar build/lib/picardcloud.jar CrosscheckFingerprints \
   I=gs://sample1.vcf \
   I=gs://sample2.vcf \
   CROSSCHECK_BY=FILE \
   H=Haplotype_db.txt \
   O=crosscheck.out
```

Alternatively, you can run the tool via the [GATK](https://software.broadinstitute.org/gatk/download/) which bundles the Google-Cloud
jar, and should thus "Just Work".

----

### Citing

Please cite this repository when using Picard tools for your publications.

“Picard Toolkit.” 2019. Broad Institute, GitHub Repository. https://broadinstitute.github.io/picard/; Broad Institute

```
@misc{Picard2019toolkit,
  title = {Picard toolkit},
  year = {2019},
  publisher = {Broad Institute},
  journal = {Broad Institute, GitHub repository},
  howpublished = {\url{https://broadinstitute.github.io/picard/}}
}
```

Identifiers from software registries are increasingly accepted by journals, as in (biotools:picard_tools) or (RRID:SCR_006525).

Picard is migrating to [semantic versioning](https://semver.org/). We will eventually adhere to it strictly and bump our major version whenever there are breaking changes to our API, but until we more clearly define what constitutes our official API, clients should assume that every release potentially contains at least minor changes to public methods.

Please see the [Picard Documentation](https://broadinstitute.github.io/picard) for more information.

[1]: https://github.com/samtools/htsjdk
[2]: https://samtools.github.io/hts-specs/
[3]: https://samtools.github.io/hts-specs/

***User Support:***


For user questions please look for answers and ask first in the [GATK forum](https://gatk.broadinstitute.org/hc/en-us/community/topics).


----


[![Build Status](https://github.com/broadinstitute/picard/actions/workflows/tests.yml/badge.svg?branch=master)](https://github.com/broadinstitute/picard/actions/workflows/tests.yml)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://github.com/broadinstitute/picard/blob/master/LICENSE.txt)

A set of Java command line tools for manipulating high-throughput sequencing (HTS) data and formats.  

Picard is implemented using the HTSJDK Java library [HTSJDK][1] to support
accessing file formats that are commonly used for high-throughput
sequencing data such as [SAM][2] and [VCF][3].  

As of version 3.0, Picard requires Java 1.17.

#### Building Picard

* First, clone the repo:
```
    git clone https://github.com/broadinstitute/picard.git
    cd picard/
```

* Picard is now built using [gradle](https://gradle.org/). A wrapper script (`gradlew`) is included which will download the appropriate version of gradle on the first invocation.
    
* To build a fully-packaged, runnable Picard jar with all dependencies included, run:
```
    ./gradlew shadowJar
```

* The resulting jar will be in `build/libs`. To run it, the command is:
```
    java -jar build/libs/picard.jar
    
    or
    
    java -jar build/libs/picard-<VERSION>-all.jar 
```    

    
* To build a jar containing only Picard classes (without its dependencies), run:
```
    ./gradlew jar
```    
    
* To clean the build directory, run:
```
    ./gradlew clean
```

#### Running Tests

* To run all tests, the command is:
```
    ./gradlew test
```

* To run a specific test, the command is:
```
    ./gradlew legacyTest --tests "*TestClassName*"
    
    or
    
    ./gradlew barclayTest --tests "*TestClassName*"
```
Running `legacyTest` uses the legacy commandline parser while `barclayTest` uses the new parser.  



#### Changing the released version of HTSJDK that Picard depends on

To switch Picard's HTSJDK dependency to a different released version:

* Open `build.gradle`
* Edit VERSION in the following line to be a different released version of HTSJDK. HTSJDK releases are listed [here](https://github.com/samtools/htsjdk/releases)
```
    final htsjdkVersion = System.getProperty('htsjdk.version', 'VERSION')`
```
* Open a pull request with this change

#### Building Picard with a Custom Version of HTSJDK

During development in Picard, it is sometimes necessary to build locally against an unreleased version or branch of HTSJDK. 

* To build against an unreleased version of HTSJDK's master branch:
    * Go to the [Broad artifactory](https://artifactory.broadinstitute.org/artifactory/simple/libs-snapshot-local/com/github/samtools/htsjdk/), where continuous snapshots of HTSJDK's master branch are published, and select the version you want to use. For example, `2.5.1-9-g5740ca1-SNAPSHOT`. You can search by tag or short git commit hash.
    * In your Picard clone, run `./gradlew shadowJar -Dhtsjdk.version=VERSION`, where VERSION is the version of the HTSJDK master branch snapshot you want to use.
    
* To build against a version of HTSJDK that has *not* yet been merged into HTSJDK's master branch:
    * Clone [HTSJDK](https://github.com/samtools/htsjdk/), and in your clone check out the tag or branch you want to build Picard with.
    * Run `./gradlew install printVersion` in your htsjdk clone to install that version to your local maven repository. Take note of the version number that gets printed at the end.
    * Switch back to your Picard clone, and run `./gradlew shadowJar -Dhtsjdk.version=VERSION`, where VERSION is the version of HTSJDK you installed to your local maven repository.

#### Releasing Picard

Full instructions on how to create a new release of 
Picard are [here](https://github.com/broadinstitute/picard/wiki/How-to-release-Picard)

#### Path providers

Picard has limited support for reading from Path providers. 
Currently only google's api is supported, and only a few tools support this.
To run with this support you need to compile the cloudJar target with gradle:
```bash
./gradlew cloudJar

```
then run picard as follows:

```bash
java -jar build/lib/picardcloud.jar <Picard arguments starting from program>
```
For example:

```bash 
java -jar build/lib/picardcloud.jar CrosscheckFingerprints \
   I=gs://sample1.vcf \
   I=gs://sample2.vcf \
   CROSSCHECK_BY=FILE \
   H=Haplotype_db.txt \
   O=crosscheck.out
```

Alternatively, you can run the tool via the [GATK](https://software.broadinstitute.org/gatk/download/) which bundles the Google-Cloud
jar, and should thus "Just Work".

----

### Citing

Please cite this repository when using Picard tools for your publications.

“Picard Toolkit.” 2019. Broad Institute, GitHub Repository. https://broadinstitute.github.io/picard/; Broad Institute

```
@misc{Picard2019toolkit,
  title = {Picard toolkit},
  year = {2019},
  publisher = {Broad Institute},
  journal = {Broad Institute, GitHub repository},
  howpublished = {\url{https://broadinstitute.github.io/picard/}}
}
```

Identifiers from software registries are increasingly accepted by journals, as in (biotools:picard_tools) or (RRID:SCR_006525).

Picard is migrating to [semantic versioning](https://semver.org/). We will eventually adhere to it strictly and bump our major version whenever there are breaking changes to our API, but until we more clearly define what constitutes our official API, clients should assume that every release potentially contains at least minor changes to public methods.

Please see the [Picard Documentation](https://broadinstitute.github.io/picard) for more information.

[1]: https://github.com/samtools/htsjdk
[2]: https://samtools.github.io/hts-specs/
[3]: https://samtools.github.io/hts-specs/

[![Build Status](https://travis-ci.org/broadinstitute/picard.svg?branch=master)](https://travis-ci.org/broadinstitute/picard)

A set of Java command line tools for manipulating high-throughput sequencing (HTS) data and formats.  

Picard is implemented using the HTSJDK Java library [HTSJDK][1] to support
accessing file formats that are commonly used for high-throughput
sequencing data such as [SAM][2] and [VCF][3].  

As of version 2.0.1 (Nov. 2015) Picard requires Java 1.8 (jdk8u66). The last version to support Java 1.7 was release 1.141.

To clone and build:
Clone the repo:

    git clone git@github.com:broadinstitute/picard.git
    cd picard/
    
Clone htsjdk into a subdirectory:

    ant clone-htsjdk
Build:

    ant

Enjoy!

    java -jar dist/picard.jar

----


It's also possible to build a version of Picard that supports reading from
GA4GH API, e.g. Google Genomics:

* Fetch [gatk-tools-java](https://github.com/googlegenomics/gatk-tools-java) 
 
```git clone https://github.com/googlegenomics/gatk-tools-java```

* Build gatk-tools-java: 

```gatk-tools-java$ mvn compile package```

* Copy the resulting jar into Picard ```lib/``` folder:
```
gatk-tools-java$ mkdir ../picard/lib/gatk-tools-java
gatk-tools-java$ cp target/gatk-tools-java*minimized.jar ../picard/lib/gatk-tools-java/
```

* Build Picard version with GA4GH support: 

```picard$ ant -lib lib/ant package-commands-ga4gh```

* If you have not yet worked with Google Genomics API and need to set up authentication, please follow the instructions [here](https://cloud.google.com/genomics/install-genomics-tools#authenticate) to set up credentials and obtain ```client_secrets.json``` file.


* You can now run 
```
java -jar dist/picard.jar ViewSam \
INPUT=https://www.googleapis.com/genomics/v1beta2/readgroupsets/CK256frpGBD44IWHwLP22R4/ \
GA4GH_CLIENT_SECRETS=../client_secrets.json
```

* To run using GRPC as opposed to REST Genomics API implementation (which is much faster) use the following command that utilizes ALPN jars that come with gatk-tools-java and enables GRPC support:
```
java \
-Xbootclasspath/p:../gatk-tools-java/lib/alpn-boot-8.1.3.v20150130.jar \
-Dga4gh.using_grpc=true \
-jar dist/picard.jar ViewSam \
INPUT=https://www.googleapis.com/genomics/v1beta2/readgroupsets/CK256frpGBD44IWHwLP22R4/ \
GA4GH_CLIENT_SECRETS=../client_secrets.json
```
For Java 7 (as opposed to 8) use ```alpn-boot-7.1.3.v20150130.jar```.

Picard is migrating to semantic versioning (http://semver.org/). We will eventually adhere to it strictly and bump our major version whenever there are breaking changes to our API, but until we more clearly define what constitutes our official API, clients should assume that every release potentially contains at least minor changes to public methods.

Please see the [Picard Documentation](http://broadinstitute.github.io/picard) for more information.

[1]: http://github.com/samtools/htsjdk
[2]: http://samtools.sourceforge.net
[3]: http://vcftools.sourceforge.net/specs.html

Description of reads (may be out of order):

perfect_fr/1 - read 1+ with no artifacts
perfect_fr/2 - read 2- with no artifacts
nbases_fr/1 - read 1+ with no artifacts, but some Ns in REFERENCE (contexts with an N _anywhere_ will be skipped)
nbases_fr/2 - read 2- with no artifacts, but some Ns in READ (N sites will be skipped, but otherwise do not affect context)
pro_oxog_fr/1 - read 1+ consistent with OxoG (G>T)
pro_oxog_fr/2 - read 2- consistent with OxoG (G>T)
pro_oxog_rf/1 - read 1- consistent with OxoG (C>A)
pro_oxog_rf/2 - read 2+ consistent with OxoG (C>A)
pro_ffpe_fr/1 - read 1+ consistent with FFPE (C>T)
pro_ffpe_fr/2 - read 2- consistent with FFPE (C>T)
con_ffpe_rf/1 - read 1- INconsistent with FFPE (C>T)
con_ffpe_rf/2 - read 2+ INconsistent with FFPE (C>T)
indel_oxog_fr/1 - read 1+ with insertion, deletion and OxoG artifact (indel sites will be skipped, but otherwise do not affect context)
indel_oxog_fr/2 - read 2- with insertion, deletion and OxoG artifact (indel sites will be skipped, but otherwise do not affect context)
unmapped_mate/1 - mapped read 1 with unmapped mate (may be filtered out)
unmapped_mate/2 - unmapped read 2 with mapped mate (mate may be filtered out)
duplicate/1 - duplicate (should always be filtered out)
duplicate/2 - duplicate (should always be filtered out)
non_primary/1 - non-primary alignment (should always be filtered out)
non_primary/2 - non-primary alignment (should always be filtered out)
low_quality/1 - has some low BASE qualities (those sites may be skipped) 
low_quality/2 - has a low MAPPING quality (may be filtered out)

## script to generate histogram of insert sizes from metrics file
## expecting 3 arguments:
## first is the metrics file with the histogram info
## second is the output file
## third is a name for the plot

args <- commandArgs(trailing=TRUE)
metricsFile <- args[1]
pdfFile <- args[2]
bamName <- args[3]
histoWidth <- ifelse(length(args) < 4, 0, as.numeric(args[4]))

startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)

firstBlankLine=0

for (i in 1:length(startFinder)) {
  if (startFinder[i] == "") {
    if (firstBlankLine==0) {
      firstBlankLine=i+1
    } else {
      secondBlankLine=i+1
      break
    }
  }
}

histogram <- read.table(metricsFile, header=TRUE, sep="\t", skip=secondBlankLine, comment.char="", quote='', check.names=FALSE)

## The histogram has a fr_count/rf_count/tandem_count for each metric "level"
## This code parses out the distinct levels so we can output one graph per level
headers <- sapply(sub(".fr_count","",names(histogram),fixed=TRUE), "[[" ,1)
headers <- sapply(sub(".rf_count","",headers,fixed=TRUE), "[[" ,1)
headers <- sapply(sub(".tandem_count","",headers,fixed=TRUE), "[[" ,1)

## Duplicated header names cause this to barf. KT & Yossi report that this is going to be extremely difficult to
## resolve and it's unlikely that anyone cares anyways. Trap this situation and avoid the PDF so it won't cause
## the workflow to fail
if (any(duplicated(headers))) {
  print(paste("Not creating insert size PDF as there are duplicated header names:", headers[which(duplicated(headers))]))
} else {
  levels <- c()
  for (i in 2:length(headers)) {
    if (!(headers[i] %in% levels)) {
      levels[length(levels)+1] <- headers[i]
    }
  }

  pdf(pdfFile)

  for (i in 1:length(levels)) {
    ## Reconstitutes the histogram column headers for this level
    fr <- paste(levels[i], "fr_count", sep=".")
    rf <- paste(levels[i], "rf_count", sep=".")
    tandem <- paste(levels[i], "tandem_count", sep=".")

    frrange = ifelse(fr %in% names(histogram), max(histogram[fr]), 0)
    rfrange = ifelse(rf %in% names(histogram), max(histogram[rf]), 0)
    tandemrange = ifelse(tandem %in% names(histogram), max(histogram[tandem]), 0)

    yrange <- max(frrange, rfrange, tandemrange)
    xrange <- ifelse(histoWidth > 0, histoWidth, max(histogram$insert_size))

    plot(x=NULL, y=NULL,
         type="n",
         main=paste("Insert Size Histogram for", levels[i], "\nin file", bamName),
         xlab="Insert Size",
         ylab="Count",
         xlim=range(0, xrange),
         ylim=range(0, yrange))

    colors <- c()
    labels <- c()

    if (fr %in% names(histogram) ) {
      lines(histogram$insert_size, as.matrix(histogram[fr]),  type="h", col="red")
      colors <- c(colors, "red")
      labels <- c(labels, "FR")
    }
    if (rf %in% names(histogram)) {
      lines(histogram$insert_size, as.matrix(histogram[rf]),  type="h", col="blue")
      colors <- c(colors, "blue")
      labels <- c(labels, "RF")
    }

    if (tandem %in% names(histogram)) {
      lines(histogram$insert_size, as.matrix(histogram[tandem]),  type="h", col="orange")
      colors <- c(colors, "orange")
      labels <- c(labels, "TANDEM")
    }

    ## Create the legend
    legend("topright", labels, fill=colors, col=colors, cex=0.7)
  }

  dev.off()
}

# Script to generate a chart of mean quality by cycle from a BAM file
# @author Tim Fennell

# Parse the arguments
args <- commandArgs(trailing=T)
metricsFile  <- args[1]
outputFile   <- args[2]
bamFile  <- args[3]
subtitle <- ifelse(length(args) < 4, "", args[4])


# Figure out where the metrics and the histogram are in the file and parse them out
startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)

firstBlankLine=0

for (i in 1:length(startFinder))
{
        if (startFinder[i] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine=i+1
                } else {
                        secondBlankLine=i+1
                        break
                }
        }
}

metrics <- read.table(metricsFile, header=T, nrows=1, sep="\t", skip=firstBlankLine)
histogram <- read.table(metricsFile, header=T, sep="\t", skip=secondBlankLine)

# Then plot the histogram as a PDF
pdf(outputFile)

plot(histogram$CYCLE,
     histogram$MEAN_QUALITY,
     type="n",
     main=paste("Quality by Cycle\nin file ",bamFile," ",ifelse(subtitle == "","",paste("(",subtitle,")",sep="")),sep=""),
     xlab="Cycle",
     ylab="Mean Quality",
     ylim=range(0,50))

qColor  <- "darkblue"
oqColor <- rgb(1, 0.25, 0.25, 0.75)

# Plot OQ first so that it's "behind" the regular qualities
if (!is.null(histogram$MEAN_ORIGINAL_QUALITY)) {
    lines(histogram$CYCLE, histogram$MEAN_ORIGINAL_QUALITY, type="l", col=oqColor, lty=1);
}

# Then plot the regular qualities
lines(histogram$CYCLE, histogram$MEAN_QUALITY, type="h", col=qColor, lty=1);

# And add a legend
legend("topleft", pch=c(15,15), legend=c("Mean Quality", "Mean Original Quality"), col=c(qColor, oqColor))


dev.off()

# Script to generate a chart of quality score distribution in a file
# @author Yossi Farjoun

# Parse the arguments
args <- commandArgs(trailing=T)
metricsFile  <- args[1]
outputFile   <- args[2]
bamFile  <- args[3]
subtitle <- ifelse(length(args) < 4, "", args[4])

# Figure out where the metrics and the histogram are in the file and parse them out
startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)

firstBlankLine=0

for (i in 1:length(startFinder))
{
        if (startFinder[i] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine=i+1
                } else {
                        secondBlankLine=i+1
                        break
                }
        }
}

metrics <- read.table(metricsFile, header=T, nrows=1, sep="\t", skip=firstBlankLine)
histogram <- read.table(metricsFile, header=T, sep="\t", skip=secondBlankLine)



# get maximal value in histogram 
M=max(histogram$READ_LENGTH)

#introduce rows for the missing ones
histogram=merge(histogram,data.frame(y=seq(0,M)),by.x = "READ_LENGTH",by.y="y",all.y = T)

#melt the histogram
melted=reshape(histogram,idvar="READ_LENGTH", varying = list(2:ncol(histogram)),direction = "long", timevar = "variable", v.names="value",  times=names(histogram)[2:ncol(histogram)],new.row.names = NULL)
rownames(melted) <- c()
#complete the missing values to zero
melted[!complete.cases(melted),"value"]=0

#remove the trailing "_LENGTH_COUNT" from the name of the variable
melted$variable=gsub("_LENGTH_COUNT","",melted$variable)

# Then plot as a PDF
pdf(outputFile)

title=paste("Read Length Distribution\nin file ",bamFile," ",ifelse(subtitle == "","",paste("(",subtitle,")",sep="")),sep="")

histograms=factor(unique(melted$variable))
plot(melted$READ_LENGTH,
     melted$value,
     type="n",
     xlab="Read-Length",
     ylab="Count",
     main=title)

cols=rainbow(length(histograms))
for (v in histograms){
    lines(melted$READ_LENGTH[melted$variable==v],melted$value[melted$variable==v],type='l',col=cols[match(v,histograms)],lwd=3)
}
legend("topleft", legend=histograms, col=cols,lwd = 3)

dev.off()

# Script to generate a chart of quality score distribution in a file
# @author Tim Fennell

# Parse the arguments
args <- commandArgs(trailing=T)
metricsFile  <- args[1]
outputFile   <- args[2]
bamFile  <- args[3]
subtitle <- ifelse(length(args) < 4, "", args[4])

# Figure out where the metrics and the histogram are in the file and parse them out
startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)

firstBlankLine=0

for (i in 1:length(startFinder))
{
        if (startFinder[i] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine=i+1
                } else {
                        secondBlankLine=i+1
                        break
                }
        }
}

metrics <- read.table(metricsFile, header=T, nrows=1, sep="\t", skip=firstBlankLine)
histogram <- read.table(metricsFile, header=T, sep="\t", skip=secondBlankLine)

# Then plot the histogram as a PDF
pdf(outputFile)

plot(histogram$QUALITY,
     histogram$COUNT_OF_Q,
     type="n",
     main=paste("Quality Score Distribution\nin file ",bamFile," ",ifelse(subtitle == "","",paste("(",subtitle,")",sep="")),sep=""),
     xlab="Quality Score",
     ylab="Observations")

qColor  <- "blue"
oqColor <- "lightcyan2"
width <- 5

# Plot OQ first so that it's "behind" the regular qualities
if (!is.null(histogram$COUNT_OF_OQ)) {
    lines(histogram$QUALITY+0.25, histogram$COUNT_OF_OQ, type="h", col=oqColor, lty=1, lwd=width, lend="square");
}

# Then plot the regular qualities
lines(histogram$QUALITY, histogram$COUNT_OF_Q, type="h", col=qColor, lty=1, lwd=width, lend="square");

# And add a legend
legend("topleft", pch=c(15,15), legend=c("Quality Scores", "Original Quality Scores"), col=c(qColor, oqColor))

dev.off()

## script to generate histogram of insert sizes from metrics file
## expecting 3 arguments:
## first is the metrics file with the histogram info
## second is the output file
## third is a name for the plot

args <- commandArgs(trailing=TRUE)
metricsFile <- args[1]
pdfFile <- args[2]
bamName <- args[3]
histoWidth <- ifelse(length(args) < 4, 0, as.numeric(args[4]))

startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)

firstBlankLine=0

for (i in 1:length(startFinder)) {
  if (startFinder[i] == "") {
    if (firstBlankLine==0) {
      firstBlankLine=i+1
    } else {
      secondBlankLine=i+1
      break
    }
  }
}

getCumulative <- function(y, yrange) {
  return ((yrange / sum(y[,1])) * rev(cumsum(rev(y[,1]))))
}

histogram <- read.table(metricsFile, header=TRUE, sep="\t", skip=secondBlankLine, comment.char="", quote='', check.names=FALSE)

## The histogram has a fr_count/rf_count/tandem_count for each metric "level"
## This code parses out the distinct levels so we can output one graph per level
headers <- sapply(sub(".fr_count","",names(histogram),fixed=TRUE), "[[" ,1)
headers <- sapply(sub(".rf_count","",headers,fixed=TRUE), "[[" ,1)
headers <- sapply(sub(".tandem_count","",headers,fixed=TRUE), "[[" ,1)

## Duplicate header names could cause this to barf.  But it really shouldn't when we have "All_reads.fr_count" and 
## "All_reads.rf_count" for example.  Not sure why this would fail, but I care.
if (any(duplicated(headers))) {
  levels = unique(headers[2:length(headers)]);
} else {
  levels <- c()
  for (i in 2:length(headers)) {
    if (!(headers[i] %in% levels)) {
      levels[length(levels)+1] <- headers[i]
    }
  }
}

pdf(pdfFile)

for (i in 1:length(levels)) {
  ## Reconstitutes the histogram column headers for this level
  fr <- paste(levels[i], "fr_count", sep=".")
  rf <- paste(levels[i], "rf_count", sep=".")
  tandem <- paste(levels[i], "tandem_count", sep=".")

  frrange = ifelse(fr %in% names(histogram), max(histogram[fr]), 0)
  rfrange = ifelse(rf %in% names(histogram), max(histogram[rf]), 0)
  tandemrange = ifelse(tandem %in% names(histogram), max(histogram[tandem]), 0)

  yrange <- max(frrange, rfrange, tandemrange)
  xrange <- ifelse(histoWidth > 0, histoWidth, max(histogram$insert_size))

  par(mar=c(5,4,4,4));
  plot(x=NULL, y=NULL,
       type="n",
       main=paste("Insert Size Histogram for", levels[i], "\nin file", bamName),
       xlab="Insert Size",
       ylab="Count",
       xlim=range(0, xrange),
       ylim=range(0, yrange))
  axis(side=4, at=seq(from=0, to=1, by=0.1)*yrange, labels=seq(from=0, to=1, by=0.10));
  mtext(side=4, line=2, text="cumulative fraction of reads > insert size");

  colors <- c()
  labels <- c()

  if (fr %in% names(histogram) ) {
    lines(histogram$insert_size, as.matrix(histogram[fr]),  type="h", col="red")
    lines(histogram$insert_size, getCumulative(histogram[fr], frrange), col="darkred", lty=2)
    colors <- c(colors, "red")
    labels <- c(labels, "FR")
  }
  if (rf %in% names(histogram)) {
    lines(histogram$insert_size, as.matrix(histogram[rf]),  type="h", col="blue")
    lines(histogram$insert_size, getCumulative(histogram[rf], rfrange), col="darkblue", lty=2)
    colors <- c(colors, "blue")
    labels <- c(labels, "RF")
   }
  if (tandem %in% names(histogram)) {
    lines(histogram$insert_size, as.matrix(histogram[tandem]),  type="h", col="orange")
    lines(histogram$insert_size, getCumulative(histogram[tandem], tandemrange), col="darkorange", lty=2)
    colors <- c(colors, "orange")
    labels <- c(labels, "TANDEM")
  }

  ## Create the legend
  legend("topright", labels, fill=colors, col=colors, cex=0.7)
}

dev.off()

# Script to generate a chart to display GC bias based upon read starts observed
# in windows along the genome.
#
# @author Tim Fennell
# @author Kylee Bergin
# edited to make multiple charts for multilevel collection

# Parse the arguments
args <- commandArgs(trailing=T)
metricsFile  <- args[1]
summaryMetricsFile <- args[2]
outputFile   <- args[3]
windowSize   <- args[4]

# Figure out where the metrics and the histogram are in the file and parse them out
startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)
startFinder2 <- scan(summaryMetricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)
firstBlankLine=0
firstBlankLine2=0
secondBlankLine2=0

for (i in 1:length(startFinder)) {
        if (startFinder[i] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine=i+1
                } else {
                        secondBlankLine=i+1
                        break
                }
        }
}

for (j in 1:length(startFinder2)) {
        if (startFinder2[j] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine2=j+1
                } else {
                        secondBlankLine2=j+1
                        break
                }
        }
}
pdf(outputFile, onefile=TRUE);

summaryMetrics <- read.table(summaryMetricsFile, header=T, sep="\t", skip=firstBlankLine2);
num.plots <- nrow(summaryMetrics);
my.plots <- vector(num.plots, mode='list');

for (k in 1:(num.plots)){
    if (k==1){
        metrics <- read.table(metricsFile, header=T, sep="\t", skip=(firstBlankLine), nrows=101);
        heads = colnames(metrics);
    }else{
        metrics <-read.table(metricsFile, header=F, sep="\t", skip=(firstBlankLine+((k-1)*101+1)), nrows=101);
        colnames(metrics) <- heads;
    }
    heads = colnames(metrics);
    # Some constants that are used below
    Y_AXIS_LIM = 2;
    MAX_QUALITY_SCORE = 40;
    COLORS = c("royalblue", "#FFAAAA", "palegreen3");

    # Adjust to give more margin on the right hand side
    par(mar = c(5, 4, 4, 4));

    accLevel = summaryMetrics[k,"ACCUMULATION_LEVEL"];
    if(accLevel=="All Reads"){datasetName <- "All Reads";}
    else{
    	if(accLevel == "Sample"){datasetName <- summaryMetrics[k, "SAMPLE"]}
    	if(accLevel == "Library"){datasetName <- summaryMetrics[k, "LIBRARY"]}
    	else(datasetName <- summaryMetrics[k, "READ_GROUP"])}
    subtitle = cat("Total clusters: ",summaryMetrics[k,"TOTAL_CLUSTERS"],", Aligned reads: ",summaryMetrics[k, "ALIGNED_READS"]);
    # Do the main plot of the normalized coverage by GC
    plot(type="p", x=metrics$GC, y=metrics$NORMALIZED_COVERAGE,
        xlab=paste(c("GC% of", windowSize, "base windows"), sep=" ", collapse=" "),
        ylab="Fraction of normalized coverage",
        xlim=c(0,100),
        ylim=c(0, Y_AXIS_LIM),
        col=COLORS[1],
        main=paste(accLevel, "Level:", datasetName, "GC Bias Plot", "\n", subtitle)
        );

    # Add lines at the 50% GC and coverage=1
    abline(h=1, v=50, col="lightgrey");

    # Plot count of windows as a separate series near the bottom
    window_ratio = 0.5 / max(metrics$WINDOWS);
    scaled_windows = metrics$WINDOWS * window_ratio;
    lines(metrics$GC, scaled_windows, type="h", col=COLORS[2], lwd=3);

    # Plot the quality series
    lines(metrics$GC, metrics$MEAN_BASE_QUALITY * Y_AXIS_LIM / MAX_QUALITY_SCORE, type="l", col=COLORS[3]);
    axis(4,
        at=c(0, Y_AXIS_LIM/4, Y_AXIS_LIM/4*2, Y_AXIS_LIM/4*3, Y_AXIS_LIM),
        labels=c(0, MAX_QUALITY_SCORE/4, MAX_QUALITY_SCORE/4*2, MAX_QUALITY_SCORE/4*3, MAX_QUALITY_SCORE)
        );
    mtext("Mean base quality", side=4, line=2.5);

    # And finally add a legend
   	legend("topleft", pch=c(1,15, 45), legend=c("Normalized Coverage", "Windows at GC%", "Base Quality at GC%"), col=COLORS)
   	p=recordPlot()
   	my.plots[[k]] <- p
}

for (my.plot in my.plots){
    replayPlot(my.plot)
}

graphics.off();

# Script to generate a chart of the base distribution by cycle
# @author Nils Homer

# Parse the arguments
args <- commandArgs(trailing=T);
metricsFile  <- args[1];
outputFile   <- args[2];
bamFile  <- args[3];
subtitle <- ifelse(length(args) < 4, "", args[4]);


# Figure out where the metrics and the histogram are in the file and parse them out
startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE);

firstBlankLine=0;

for (i in 1:length(startFinder)) {
        if (startFinder[i] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine=i+1;
                } else {
                        secondBlankLine=i+1;
                        break;
                }
        }
}

metrics <- read.table(metricsFile, header=T, sep="\t", skip=firstBlankLine);

# Then plot the histogram as a PDF
pdf(outputFile);

plot(x=c(1, 20+nrow(metrics)),
     y=c(0, max(metrics[,3:7])),
     main=paste("Base Distribution by Cycle\nin file ",bamFile," ",ifelse(subtitle == "","",paste("(",subtitle,")",sep="")),sep=""),
     xlab="Cycle",
     ylab="Base Percentage",
     type="n");

colors = c("red", "orange", "blue", "purple", "black");

for (i in 1:5) {
    lines(x=1:nrow(metrics),
        y=metrics[,2+i],
        col=colors[i],
        type="l",
        lty=1);
}

legend("bottomright", lwd=1, legend=c("PCT_A", "PCT_C", "PCT_G", "PCT_T", "PCT_N"), col=colors);

dev.off();

# Script to generate a normalized coverage vs. position along transcript plot.
#
# @author Tim Fennell

# Parse the arguments
args <- commandArgs(trailing = TRUE)
metricsFile  <- args[1]
outputFile   <- args[2]
bamName  <- args[3]
subtitle <- ifelse(length(args) < 4, "", args[4])

# Figure out where the metrics and the histogram are in the file and parse them out
startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)

firstBlankLine=0

for (i in 1:length(startFinder)) {
        if (startFinder[i] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine=i+1
                } else {
                        secondBlankLine=i+1
                        break
                }
        }
}

data <- read.table(metricsFile, header=T, sep="\t", skip=secondBlankLine, check.names=FALSE)

# The histogram has a normalized_position and normalized_coverage column for each metric "level"
# This code parses out the distinct levels so we can output one graph per level
headers <- sapply(sub(".normalized_coverage","",names(data),fixed=TRUE), "[[" ,1)

## Duplicated header names cause this to barf. KT & Yossi report that this is going to be extremely difficult to
## resolve and it's unlikely that anyone cares anyways. Trap this situation and avoid the PDF so it won't cause
## the workflow to fail
if (any(duplicated(headers))) {
  print(paste("Not creating insert size PDF as there are duplicated header names:", headers[which(duplicated(headers))]))
} else {
    pdf(outputFile)
    levels <- c()
    for (i in 2:length(headers)) {
        if (!(headers[i] %in% levels)) {
            levels[length(levels)+1] <- headers[i]
        }
    }

    # Some constants that are used below
    COLORS = c("royalblue", "#FFAAAA", "palegreen3");

    # For each level, plot of the normalized coverage by GC
    for (i in 1:length(levels)) {

        # Reconstitutes the histogram column header for this level
        nc <- paste(levels[i], "normalized_coverage", sep=".")

        plot(x=data$normalized_position, y=as.matrix(data[nc]),
            type="o",
            xlab="Normalized Distance Along Transcript",
            ylab="Normalized Coverage",
            xlim=c(0, 100),
            ylim=range(0, max(data[nc])),
            col="royalblue",
            main=paste("RNA-Seq Coverage vs. Transcript Position\n", levels[i], " ", ifelse(subtitle=="", "", paste("(", subtitle, ")", sep="")), "\nin file ", bamName,sep=""))

        # Add a horizontal line at coverage=1
        abline(h=1, col="lightgrey");
    }
    dev.off();
}

##
## The MIT License
##
## Copyright (c) 2013 The Broad Institute
##
## Permission is hereby granted, free of charge, to any person obtaining a copy
## of this software and associated documentation files (the "Software"), to deal
## in the Software without restriction, including without limitation the rights
## to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
## copies of the Software, and to permit persons to whom the Software is
## furnished to do so, subject to the following conditions:
##
## The above copyright notice and this permission notice shall be included in
## all copies or substantial portions of the Software.
##
## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
## AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
## LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
## OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
## THE SOFTWARE.
##

args = commandArgs(trailingOnly=TRUE)
opt = list(details.fn=args[1], summary.fn=args[2], output.fn=args[3])

read_metrics_file = function(metrics.fn) {
  contents = read.delim(metrics.fn, comment.char="#", stringsAsFactors=FALSE)
  return(contents)
}

equals_or_is_na = function(x1, x2) {
  if (is.na(x1)) {
    return(is.na(x2))
  } else {
    return(x1 == x2)
  }
}

details = read_metrics_file(opt$details.fn)
summary = read_metrics_file(opt$summary.fn)

pdf(opt$output.fn)
par(mfrow=c(2,2), oma=c(0,0,2,0))

for (i in seq_len(nrow(summary))) {
  cur_summary = summary[i, ]
  cur_sample = cur_summary[1, "SAMPLE"]
  cur_library = cur_summary[1, "LIBRARY"]
  cur_read_group = cur_summary[1, "READ_GROUP"]
  cur_details = details[which((equals_or_is_na(cur_library, details[, "LIBRARY"]) &
    (equals_or_is_na(cur_sample, details[, "SAMPLE"])) &
    (equals_or_is_na(cur_read_group, details[, "READ_GROUP"])))), ]
  
  
  ## Plot conversion rates
  cpg.converted = sum(cur_details$CONVERTED_SITES)
  cpg.seen = sum(cur_details$TOTAL_SITES)
  cpg.conversion = cpg.converted / cpg.seen
  total.conversion = (cpg.converted + cur_summary$NON_CPG_CONVERTED_BASES) / (cpg.seen + cur_summary$NON_CPG_BASES)

  barplot(c("non-CpG"=cur_summary$PCT_NON_CPG_BASES_CONVERTED, "Combined"=total.conversion, "CpG"=cpg.conversion),
          ylim=c(0.95, 1), ylab="% Conversion", xlab="Distribution", main="Bisulfite Conversion Rate",
          col="blue", xpd=FALSE)
  abline(h=0.995, col="grey")
  
  ## Plot histogram of CpG counts by conversion rate
  hist(cur_details$PCT_CONVERTED, 10, xlab="Conversion Rate Of CpGs", ylab="# CpGs",
       main="CpG Conversion Rate Distribution", col="blue")
  
  ## Plot pie chart showing distribution of CpG coverage
  coverage_breaks = c(0, 1, 5, 10, 25, 50, 100, Inf)
  coverage_cut = cut(cur_details$TOTAL_SITES, coverage_breaks)
  cpg_coverage = split(cur_details$TOTAL_SITES, coverage_cut)
  coverages = sapply(cpg_coverage, length)[2:7]
  names(coverages) = paste(">=", c(1, 5, 10, 25, 50, 100), sep="")
  ## If we have 0s all across the pie chart will be effectively meaningless but put in a 100% >= 0 field instead
  ## to avoid an error on pie(). Normally it'd just be a pain to see these, but ...
  if (all(coverages == 0)) {
    coverages = c("No Coverage"=1)
  }
  color_ramp = colorRampPalette(c("white", "#538ED5", "blue"), bias=1, space="Lab")
  colors = color_ramp(length(coverages))[2:length(coverages)]
  pie(coverages, main="Distribution Of CpGs By Coverage", col=colors, clockwise=TRUE)
  
  discards = log10(c("Mismatches"=cur_summary$READS_IGNORED_MISMATCHES, "Size"=cur_summary$READS_IGNORED_SHORT))
  ## Protect against -Inf in the case where we had 0 discards
  discards = ifelse(is.finite(discards), discards, 0)
  barplot(discards, ylab="Number Discarded (log10)", xlab="Reason",
          main="Reads Discarded", col="blue", ylim=c(0, ceiling(max(discards))))

  header_txt = character()
  if (!is.na(cur_sample) && cur_sample != "") {
    header_txt = paste(header_txt, " SAMPLE=", cur_sample, sep="")
  }
  if (!is.na(cur_library) && cur_library != "") {
    header_txt = paste(header_txt, " LIBRARY=", cur_library, sep="")
  }
  if (!is.na(cur_read_group) && cur_read_group != "") {
    header_txt = paste(header_txt, " READ GROUP=", cur_read_group, sep="")
  }
  if (length(header_txt) > 0) {
    mtext(header_txt, outer=TRUE, line=1)
  }
}

dev.off()
  

# Script to generate a chart to display GC bias based upon read starts observed
# in windows along the genome.
#
# @author Tim Fennell
# @author Kylee Bergin
# edited to make multiple charts for multilevel collection

# Parse the arguments
args <- commandArgs(trailing=T)
metricsFile  <- args[1]
summaryMetricsFile <- args[2]
outputFile   <- args[3]
windowSize   <- args[4]

# Figure out where the metrics and the histogram are in the file and parse them out
startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)
startFinder2 <- scan(summaryMetricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)
firstBlankLine=0
firstBlankLine2=0
secondBlankLine2=0

for (i in 1:length(startFinder)) {
        if (startFinder[i] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine=i+1
                } else {
                        secondBlankLine=i+1
                        break
                }
        }
}

for (j in 1:length(startFinder2)) {
        if (startFinder2[j] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine2=j+1
                } else {
                        secondBlankLine2=j+1
                        break
                }
        }
}
pdf(outputFile, onefile=TRUE);

summaryMetrics <- read.table(summaryMetricsFile, header=T, sep="\t", skip=firstBlankLine2);
num.plots <- nrow(summaryMetrics);
my.plots <- vector(num.plots, mode='list');

for (k in 1:(num.plots)){
    if (k==1){
        metrics <- read.table(metricsFile, header=T, sep="\t", skip=(firstBlankLine), nrows=101);
        heads = colnames(metrics);
    }else{
        metrics <-read.table(metricsFile, header=F, sep="\t", skip=(firstBlankLine+((k-1)*101+1)), nrows=101);
        colnames(metrics) <- heads;
    }
    heads = colnames(metrics);
    # Some constants that are used below
    Y_AXIS_LIM = 2;
    MAX_QUALITY_SCORE = 40;
    COLORS = c("royalblue", "#FFAAAA", "palegreen3");

    # Adjust to give more margin on the right hand side
    par(mar = c(5, 4, 4, 4));

    accLevel = summaryMetrics[k,"ACCUMULATION_LEVEL"];
    if(accLevel=="All Reads"){datasetName <- "All Reads";}
    else{
    	if(accLevel == "Sample"){datasetName <- summaryMetrics[k, "SAMPLE"]}
    	if(accLevel == "Library"){datasetName <- summaryMetrics[k, "LIBRARY"]}
    	else(datasetName <- summaryMetrics[k, "READ_GROUP"])}
    duplicatesMarker <- ifelse(summaryMetrics[k, "READS_USED"] == "ALL", "", " (duplicates excluded) ");
    subtitle = cat("Total clusters: ",summaryMetrics[k,"TOTAL_CLUSTERS"],", Aligned reads: ",summaryMetrics[k, "ALIGNED_READS"]);
    # Do the main plot of the normalized coverage by GC
    plot(type="p", x=metrics$GC, y=metrics$NORMALIZED_COVERAGE,
        xlab=paste(c("GC% of", windowSize, "base windows"), sep=" ", collapse=" "),
        ylab="Fraction of normalized coverage",
        xlim=c(0,100),
        ylim=c(0, Y_AXIS_LIM),
        col=COLORS[1],
        main=paste(accLevel, "Level:", datasetName, duplicatesMarker, "GC Bias Plot", "\n", subtitle)
        );

    # Add lines at the 50% GC and coverage=1
    abline(h=1, v=50, col="lightgrey");

    # Plot count of windows as a separate series near the bottom
    window_ratio = 0.5 / max(metrics$WINDOWS);
    scaled_windows = metrics$WINDOWS * window_ratio;
    lines(metrics$GC, scaled_windows, type="h", col=COLORS[2], lwd=3);

    # Plot the quality series
    lines(metrics$GC, metrics$MEAN_BASE_QUALITY * Y_AXIS_LIM / MAX_QUALITY_SCORE, type="l", col=COLORS[3]);
    axis(4,
        at=c(0, Y_AXIS_LIM/4, Y_AXIS_LIM/4*2, Y_AXIS_LIM/4*3, Y_AXIS_LIM),
        labels=c(0, MAX_QUALITY_SCORE/4, MAX_QUALITY_SCORE/4*2, MAX_QUALITY_SCORE/4*3, MAX_QUALITY_SCORE)
        );
    mtext("Mean base quality", side=4, line=2.5);

    # And finally add a legend
   	legend("topleft", pch=c(1,15, 45), legend=c("Normalized Coverage", "Windows at GC%", "Base Quality at GC%"), col=COLORS)
   	p=recordPlot()
   	my.plots[[k]] <- p
}

for (my.plot in my.plots){
    replayPlot(my.plot)
}

graphics.off();

# Script to generate a chart to display GC bias based upon read starts observed
# in windows along the genome.
#
# @author Tim Fennell

# Parse the arguments
args <- commandArgs(trailing=T)
metricsFile  <- args[1]
outputFile   <- args[2]
datasetName  <- args[3]
subtitle  <- args[4]
windowSize   <- args[5]

# Figure out where the metrics and the histogram are in the file and parse them out
startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)

firstBlankLine=0

for (i in 1:length(startFinder)) {
        if (startFinder[i] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine=i+1
                } else {
                        secondBlankLine=i+1
                        break
                }
        }
}

metrics <- read.table(metricsFile, header=T, sep="\t", skip=firstBlankLine)
pdf(outputFile)

# Some constants that are used below
Y_AXIS_LIM = 2;
MAX_QUALITY_SCORE = 40;
COLORS = c("royalblue", "#FFAAAA", "palegreen3");

# Adjust to give more margin on the right hand side
par(mar = c(5, 4, 4, 4));

# Do the main plot of the normalized coverage by GC
plot(type="p", x=metrics$GC, y=metrics$NORMALIZED_COVERAGE,
     xlab=paste(c("GC% of", windowSize, "base windows"), sep=" ", collapse=" "),
     ylab="Fraction of normalized coverage",
     xlim=c(0,100),
     ylim=c(0, Y_AXIS_LIM),
     col=COLORS[1],
     main=paste(datasetName, "GC Bias Plot", "\n", subtitle)
    );

# Add lines at the 50% GC and coverage=1
abline(h=1, v=50, col="lightgrey");

# Add error bars
arrows(metrics$GC,
       metrics$NORMALIZED_COVERAGE - metrics$ERROR_BAR_WIDTH,
       metrics$GC,
       metrics$NORMALIZED_COVERAGE + metrics$ERROR_BAR_WIDTH,
       code = 3, angle = 90, length = 0.05, col="grey");

# Plot count of windows as a separate series near the bottom
window_ratio = 0.5 / max(metrics$WINDOWS);
scaled_windows = metrics$WINDOWS * window_ratio;
lines(metrics$GC, scaled_windows, type="h", col=COLORS[2], lwd=3);

# Plot the quality series
lines(metrics$GC, metrics$MEAN_BASE_QUALITY * Y_AXIS_LIM / MAX_QUALITY_SCORE, type="l", col=COLORS[3]);
axis(4,
     at=c(0, Y_AXIS_LIM/4, Y_AXIS_LIM/4*2, Y_AXIS_LIM/4*3, Y_AXIS_LIM),
     labels=c(0, MAX_QUALITY_SCORE/4, MAX_QUALITY_SCORE/4*2, MAX_QUALITY_SCORE/4*3, MAX_QUALITY_SCORE)
    );
mtext("Mean base quality", side=4, line=2.5);

# And finally add a legend
legend("topleft", pch=c(1,15, 45), legend=c("Normalized Coverage", "Windows at GC%", "Base Quality at GC%"), col=COLORS)

dev.off();

##
# Copyright (c) 2016-2017, Nils Homer
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
##

# Script to generate a chart for the fraction of bases at a given mean fold coverage.
# @author Nils Homer

# Parse the arguments
args <- commandArgs(trailing=T)
metricsFile  <- args[1]
outputFile   <- args[2]
bamFile  <- ifelse(length(args) < 3, NA, args[3])
subtitle <- ifelse(length(args) < 4, "", args[4])

# Figure out where the metrics and the histogram are in the file and parse them out
startFinder <- scan(metricsFile, what="character", sep="\n", quiet=TRUE, blank.lines.skip=FALSE)

firstBlankLine=0

for (i in 1:length(startFinder))
{
        if (startFinder[i] == "") {
                if (firstBlankLine==0) {
                        firstBlankLine=i+1
                } else {
                        secondBlankLine=i+1
                        break
                }
        }
}

metrics <- read.table(metricsFile, header=T, nrows=2, sep="\t", skip=firstBlankLine)
histogram <- read.table(metricsFile, header=T, sep="\t", skip=secondBlankLine)

coverages = rbind(histogram$coverage, histogram$coverage)
counts = rbind(histogram$count_WHOLE_GENOME, histogram$count_NON_ZERO_REGIONS)
labels = c("Whole Genome", "Non-Zero Regions")
colors = c("blue", "green")

ymins = c();
ymaxs = c();
percentOfMeans = c()
percentCovereds = c();

for (i in 1:2) {
	coverage = coverages[i,];
	count = counts[i,];

	coverage = coverage[!is.na(count)];
	count = count[!is.na(count)];

	meanCoverage = as.numeric(metrics$MEAN_COVERAGE[i]);
	percentOfMean <- coverage / meanCoverage; # x-axis
	percentCovered <- rep(0, length(count)); # y-axis

	# must do a cumulative sum of percentCovered
	totalCount = sum(as.numeric(count));
	for (j in 1:length(percentCovered)) {
		percentCovered[j] = sum(as.numeric(count[j:length(percentCovered)])) / totalCount;
	}

	ymin = percentCovered[round(meanCoverage+1)]
	ymax = min(100,max(percentCovered));

	ymins = append(ymins, ymin);
	ymaxs = append(ymaxs, ymax);
	percentOfMeans = append(percentOfMeans, list(percentOfMean));
	percentCovereds = append(percentCovereds, list(percentCovered));
}

ymin = min(0, min(ymins, na.rm=T));
ymax = max(ymaxs, na.rm=T);

# Then plot the histogram as a PDF
pdf(outputFile);

plot(x=c(0, 1.0),
		y=c(ymin, ymax),
		xlim=c(0, 1.0),
		ylim=c(ymin, ymax),
		type="n",
		main=paste("WGS Base Coverage Plot", ifelse(is.na(bamFile),"",paste("\nin file",bamFile))," ",ifelse(subtitle == "","",paste("(",subtitle,")",sep="")),sep=""),
		xlab="Fold Coverage of Mean",
		ylab="% of Bases Covered");

for (i in 1:2) {
	label = labels[i];
	color = colors[i]
	percentOfMean = percentOfMeans[[i]];
	percentCovered = percentCovereds[[i]];

	lines(percentOfMean, percentCovered, col=color, lwd=5);
}

legend(x="topright", legend=labels, lwd=5, col=colors);

dev.off()

#!/usr/bin/env bash

# This script is used to build and deploy the GCR docker image for Picard
# The dockerhub image is built using a dockerhub automated build: https://hub.docker.com/r/broadinstitute/picard/builds

if [[ "$1" == "" ]]
then
    echo "Usage: build_push_docker.sh <git-tag>"
    exit 1
fi

declare -r TAG=${1}

declare -r PICARD_CLOUD_TAG=us.gcr.io/broad-gotc-prod/picard-cloud:${TAG}

echo "Will build and push the following docker images:"
echo ${PICARD_CLOUD_TAG}

read -p "Is this really what you want to do? " -n 1 -r
echo    # (optional) move to a new line
if [[ $REPLY =~ ^[Yy]$ ]]
then
    docker build -t ${PICARD_CLOUD_TAG} --build-arg release=true .
    docker push ${PICARD_CLOUD_TAG}
fi

#! /bin/bash

# The MIT License
#
# Copyright (c) $today.year The Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
echo "This release script has been DEPRECATED. Please use the gradle build file for releases."
#
# PROGNAME=`basename $0`
#
# function usage () {
#     echo "USAGE: $PROGNAME <release-id>" >&2
# 	echo "Tags Github Picard source, checks out and builds sources, uploads build results to Sourceforge.">&2
#     echo "-t <tmpdir>                Build in <tmpdir>.  Default: $TMPDIR." >&2
# }
#
# function create_release () {
# 	local token="$1";
# 	local owner="$2";
# 	local repo="$3";
# 	local tag_name="$4";
# 	local target_commitish="$5";
# 	local name="$6";
# 	local body="$7";
# 	local draft="$8";
# 	local prerelease="$9";
#
# 	local payload="\"tag_name\":\"$tag_name\"";
# 	payload="$payload,\"target_commitish\":\"$target_commitish\"";
# 	payload="$payload,\"name\":\"$name\"";
# 	payload="$payload,\"body\":\"$body\"";
# 	payload="$payload,\"draft\":$draft";
# 	payload="$payload,\"prerelease\":$prerelease";
# 	payload="{$payload}";
#
# 	RELEASE_RESPONSE=$(curl --fail -s -S -X POST \
# 		https://api.github.com/repos/$owner/$repo/releases \
# 		-A "create-release" \
# 		-H "Accept: application/vnd.github.v3+json" \
# 		-H "Content-Type: application/json" \
# 		-H "Authorization: token $token" \
# 		-d "$payload");
#
# 	# NB: we must set the RELEASE_GITHUB_ID as the ID in the returned json response
# 	export RELEASE_GITHUB_ID=$(echo "$RELEASE_RESPONSE" | sed -e 's_",.*__g' -e 's_.*/__g')
# }
#
# function upload_asset () {
# 	local token="$1";
# 	local owner="$2";
# 	local repo="$3";
# 	local name="$4";
# 	local content_type="$5";
# 	local file="$6";
# 	local id="$7";
#
# 	curl --fail -s -S -X POST \
# 		https://uploads.github.com/repos/$owner/$repo/releases/$id/assets?name=$name \
# 		-A "upload-asset" \
# 		-H "Accept: application/vnd.github.v3+json" \
# 		-H "Content-Type: $content_type" \
# 		-H "Authorization: token $token" \
# 		--progress-bar \
# 		--data-binary @"$file";
# }
#
# function tag_exists() {
#     git tag | grep -q "$1$"
#     if test $? = 0
#         then return 0
#         else return 1
#     fi
# }
#
# function remote_does_not_exist() {
#     git ls-remote $1 2>/dev/null 1>/dev/null
#     if test $? = 0
#         then return 1
#         else return 0
#     fi
# }
#
# function remote_tag_does_not_exist() {
#     git ls-remote --tags $2 | grep -q "$1$";
#     if test $? = 0
#         then return 0
#         else return 1
#     fi
# }
#
#
# # This method called once for picard and once for htsjdk
# function tag_it() {
#
#     # tag must not exist
#     if tag_exists $RELEASE_ID
#     then echo "ERROR: Tag $RELEASE_ID locally already exists"
#          return 1
#     fi
#
#     # remote must exist
#     if remote_does_not_exist $REMOTE
#     then echo "ERROR: Remote $REMOTE does not exist"
#          return 1
#     fi
#
#     # tag at remote must not exist
#     if remote_tag_does_not_exist $RELEASE_ID $REMOTE
#     then echo "ERROR: Tag $RELEASE_ID at remote $REMOTE already exists"
#          return 1
#     fi
#
#     # tag the branch locally then push to remote
#     echo Tagging master as $RELEASE_ID and pushing the tag to $REMOTE
#     # NB: we could use annotated tags in the future to store release notes, etc.
#     git tag $RELEASE_ID
#     git push $REMOTE $RELEASE_ID # TODO: should we check this return value in case someone made a tag since we last checked?
# }
#
# set -e
#
# while getopts "ht:" options; do
#   case $options in
#     t ) TMPDIR=$OPTARG;;
#     h ) usage;;
#     \? ) usage
#          exit 1;;
#     * ) usage
#           exit 1;;
#   esac
# done
# shift $(($OPTIND - 1))
#
# if [ -z $GITHUB_USER_TOKEN ]
# then echo "ERROR: environment variable GITHUB_USER_TOKEN must be set." >&2
# 	usage
# 	exit 1
# fi
#
# if (( $# != 1 ))
# then echo "ERROR: Incorrect number of arguments." >&2
#       usage
#       exit 1
# fi
#
# if [[ x"$EDITOR" == x ]]
# then echo "EDITOR environment variable must be set." >&2
#        exit 1
# fi
#
# java_version=`java -version 2>&1 | fgrep -i version`
#
# PICARDGITROOT=git@github.com:broadinstitute/picard.git
# REMOTE=origin
# GHPAGES_BRANCH="gh-pages"
#
# RELEASE_ID=$1
#
# # Since releases are lexically sorted, need to filter in order to have 1.1xx be at the bottom.
# PICARD_PREV_RELEASE_ID=`git ls-remote --tags | grep -v "{}$" | awk '{print $2}' | sed -e "s_.*/__g" | egrep '[.]\d\d\d' | tail -1`
#
# if [[ -e $TMPDIR/picard ]]
# then echo "$TMPDIR/picard already exists.  Please remove or specify a different TMPDIR." >&2
#         exit 1
# fi
# echo "Using TMPDIR: $TMPDIR";
# cd $TMPDIR
#
# # clone
# git clone $PICARDGITROOT picard
# cd picard
# ant clone-htsjdk
# #by default clone will grab the latest release we need master
# cd htsjdk
# git checkout master
# cd ..
# ant clean # clean shouldn't be necessary, but no harm
#
# # Since releases are lexically sorted, need to filter in order to have 1.1xx be at the bottom.
# PICARD_PREV_RELEASE_ID=`git ls-remote --tags | grep -v "{}$" | awk '{print $2}' | sed -e "s_.*/__g" | egrep '[.]\d\d\d' | tail -1`
# HTSJDK_PREV_RELEASE_ID=$(cd htsjdk; git ls-remote --tags | grep -v "{}$" | awk '{print $2}' | sed -e "s_.*/__g" | egrep '[.]\d\d\d' | tail -1)
#
# # Tag in both repos
# for sandbox in . htsjdk
# do pushd $sandbox
# 	tag_it || exit 1
# 	popd
# done
#
# ant -lib lib/ant test-htsjdk test
#
# ant -lib lib/ant clean all javadoc
#
# mkdir -p deploy/picard-tools/$RELEASE_ID
#
# git log --name-status ${PICARD_PREV_RELEASE_ID}..${RELEASE_ID} > deploy/picard-tools/$RELEASE_ID/README.txt
#
# (cd htsjdk; git log --name-status  ${HTSJDK_PREV_RELEASE_ID}..${RELEASE_ID}) >> deploy/picard-tools/$RELEASE_ID/README.txt
#
# echo 'Edit release notes and exit editor when finished.'
#
# $EDITOR deploy/picard-tools/$RELEASE_ID/README.txt
#
# cp dist/picard-tools-$RELEASE_ID.zip deploy/picard-tools/$RELEASE_ID/
#
# # Make all files to be pushed to Sourceforge writable by group so that another Picard admin can overwrite them.
#
# chmod -R gu+rw javadoc deploy dist
#
# find javadoc deploy dist -type d -exec chmod g+s '{}' ';'
#
# # Move the javadoc directory to a temporary location
# mv javadoc tmp_javadoc
#
# # Copy over javadoc for htsjdk since we are in the picard directory
# # NB: need to move javadoc to a tmp directory since the javadoc
# # directory in the gh-pages branch may already exist.
# cd htsjdk
# mkdir tmp_javadoc
# cp -r ../tmp_javadoc/htsjdk tmp_javadoc/.
# cd ../
#
# # Update the javadoc
# for sandbox in . htsjdk
# do pushd $sandbox
# 	if [ "." == $sandbox ]; then
# 		sandbox="picard";
# 	fi
# 	echo "Updating the javadoc for $sandbox"
# 	# Checkout the gh-pages branch
# 	git checkout -b $GHPAGES_BRANCH $REMOTE/$GHPAGES_BRANCH
# 	# Copy over from the tmp javadoc directory
# 	if [ ! -d javadoc ]; then
# 		mkdir javadoc;
# 	fi
# 	rsync -avP --delete-after tmp_javadoc/* javadoc/.
# 	# Remove the tmp directory as we no longer need it
# 	rm -r tmp_javadoc
# 	# Add the new javadoc files
# 	find javadoc/$sandbox | xargs git add
# 	# Commit!
# 	git commit -a --allow-empty -m "Updating javadoc for release: $RELEASE_ID"
# 	# NB: assumes the push will not fail
# 	git push $REMOTE $GHPAGES_BRANCH
# 	# Reset the repository to master
# 	git checkout master
# 	echo "Updated the javadoc for $sandbox"
# 	popd
# done
#
# # Publish a release and upload assets
# echo "Creating a release on github for htsjdk and picard"
# create_release $GITHUB_USER_TOKEN samtools htsjdk $RELEASE_ID "" $RELEASE_ID "Release $RELEASE_ID" "false" "false";
# create_release $GITHUB_USER_TOKEN broadinstitute picard $RELEASE_ID "" $RELEASE_ID "Release $RELEASE_ID" "false" "false";
# echo "Github release id: $RELEASE_GITHUB_ID"
# echo "Updating the release zip and README.txt to github"
# upload_asset $GITHUB_USER_TOKEN broadinstitute picard picard-tools-$RELEASE_ID.zip "application/zip" deploy/picard-tools/$RELEASE_ID/picard-tools-$RELEASE_ID.zip $RELEASE_GITHUB_ID;
# upload_asset $GITHUB_USER_TOKEN broadinstitute picard README.txt "application/zip" deploy/picard-tools/$RELEASE_ID/README.txt $RELEASE_GITHUB_ID;
#
# # Update the website
# echo "Updating the website"
# # Assumes the gh-pages branch is already locally created
# git checkout $GHPAGES_BRANCH;
# cd dist/html
# cp inc/*.html program_usage/*.html picard-metric-definitions.html ../../_includes/.
# cd ../../
# find _includes | xargs git add
# git commit -a --allow-empty -m "Adding website files for $RELEASE_ID"
# git push $REMOTE $GHPAGES_BRANCH
#
# # Move back to master just in case
# git checkout master
#
# echo "Release was successful!"

#! /bin/bash

# The MIT License
#
# Copyright (c) $today.year The Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN

PROGNAME=`basename $0`

function usage () {
    echo "USAGE: $PROGNAME <release-id>" >&2
	echo "Tags Github Picard source, checks out and builds sources, uploads build results to Sourceforge.">&2
    echo "-t <tmpdir>                Build in <tmpdir>.  Default: $TMPDIR." >&2
}

function create_release () {
	local token="$1";
	local owner="$2";
	local repo="$3";
	local tag_name="$4";
	local target_commitish="$5";
	local name="$6";
	local body="$7";
	local draft="$8";
	local prerelease="$9";

	local payload="\"tag_name\":\"$tag_name\"";
	payload="$payload,\"target_commitish\":\"$target_commitish\"";
	payload="$payload,\"name\":\"$name\"";
	payload="$payload,\"body\":\"$body\"";
	payload="$payload,\"draft\":$draft";
	payload="$payload,\"prerelease\":$prerelease";
	payload="{$payload}";

	RELEASE_RESPONSE=$(curl --fail -s -S -X POST \
		https://api.github.com/repos/$owner/$repo/releases \
		-A "create-release" \
		-H "Accept: application/vnd.github.v3+json" \
		-H "Content-Type: application/json" \
		-H "Authorization: token $token" \
		-d "$payload");

	# NB: we must set the RELEASE_GITHUB_ID as the ID in the returned json response
	export RELEASE_GITHUB_ID=$(echo "$RELEASE_RESPONSE" | sed -e 's_",.*__g' -e 's_.*/__g')
}

function upload_asset () {
	local token="$1";
	local owner="$2";
	local repo="$3";
	local name="$4";
	local content_type="$5";
	local file="$6";
	local id="$7";

	curl --fail -s -S -X POST \
		https://uploads.github.com/repos/$owner/$repo/releases/$id/assets?name=$name \
		-A "upload-asset" \
		-H "Accept: application/vnd.github.v3+json" \
		-H "Content-Type: $content_type" \
		-H "Authorization: token $token" \
		--progress-bar \
		--data-binary @"$file";
}

function tag_exists() {
    git tag | grep -q "$1$"
    if test $? = 0
        then return 0
        else return 1
    fi
}

function remote_does_not_exist() {
    git ls-remote $1 2>/dev/null 1>/dev/null
    if test $? = 0
        then return 1
        else return 0
    fi
}

function remote_tag_does_not_exist() {
    git ls-remote --tags $2 | grep -q "$1$";
    if test $? = 0
        then return 0
        else return 1
    fi
}


# This method called once for picard and once for htsjdk
function tag_it() {

    # tag must not exist
    if tag_exists $RELEASE_ID
    then echo "ERROR: Tag $RELEASE_ID locally already exists"
         return 1
    fi

    # remote must exist
    if remote_does_not_exist $REMOTE
    then echo "ERROR: Remote $REMOTE does not exist"
         return 1
    fi

    # tag at remote must not exist
    if remote_tag_does_not_exist $RELEASE_ID $REMOTE
    then echo "ERROR: Tag $RELEASE_ID at remote $REMOTE already exists"
         return 1
    fi

    # tag the branch locally then push to remote
    echo Tagging master as $RELEASE_ID and pushing the tag to $REMOTE
    # NB: we could use annotated tags in the future to store release notes, etc.
    git tag $RELEASE_ID
    git push $REMOTE $RELEASE_ID # TODO: should we check this return value in case someone made a tag since we last checked?
}

set -e

while getopts "ht:" options; do
  case $options in
    t ) TMPDIR=$OPTARG;;
    h ) usage;;
    \? ) usage
         exit 1;;
    * ) usage
          exit 1;;
  esac
done
shift $(($OPTIND - 1))

if [ -z $GITHUB_USER_TOKEN ]
then echo "ERROR: environment variable GITHUB_USER_TOKEN must be set." >&2
	usage
	exit 1
fi

if (( $# != 1 ))
then echo "ERROR: Incorrect number of arguments." >&2
      usage
      exit 1
fi

if [[ x"$EDITOR" == x ]]
then echo "EDITOR environment variable must be set." >&2
       exit 1
fi

java_version=`java -version 2>&1 | fgrep -i version`

PICARDGITROOT=git@github.com:broadinstitute/picard.git
REMOTE=origin
GHPAGES_BRANCH="gh-pages"

RELEASE_ID=$1

# Since releases are lexically sorted, need to filter in order to have 1.1xx be at the bottom.
PICARD_PREV_RELEASE_ID=`git ls-remote --tags | grep -v "{}$" | awk '{print $2}' | sed -e "s_.*/__g" | egrep '[.]\d\d\d' | tail -1`

if [[ -e $TMPDIR/picard ]]
then echo "$TMPDIR/picard already exists.  Please remove or specify a different TMPDIR." >&2
        exit 1
fi
echo "Using TMPDIR: $TMPDIR";
cd $TMPDIR

# clone
git clone $PICARDGITROOT picard
cd picard
ant clone-htsjdk
ant clean # clean shouldn't be necessary, but no harm

# Since releases are lexically sorted, need to filter in order to have 1.1xx be at the bottom.
PICARD_PREV_RELEASE_ID=`git ls-remote --tags | grep -v "{}$" | awk '{print $2}' | sed -e "s_.*/__g" | egrep '[.]\d\d\d' | tail -1`
HTSJDK_PREV_RELEASE_ID=$(cd htsjdk; git ls-remote --tags | grep -v "{}$" | awk '{print $2}' | sed -e "s_.*/__g" | egrep '[.]\d\d\d' | tail -1)

# Tag in both repos
for sandbox in . htsjdk
do pushd $sandbox
	tag_it || exit 1
	popd
done

ant -lib lib/ant test-htsjdk test

ant -lib lib/ant clean all javadoc

mkdir -p deploy/picard-tools/$RELEASE_ID

git log --name-status ${PICARD_PREV_RELEASE_ID}..${RELEASE_ID} > deploy/picard-tools/$RELEASE_ID/README.txt

(cd htsjdk; git log --name-status  ${HTSJDK_PREV_RELEASE_ID}..${RELEASE_ID}) >> deploy/picard-tools/$RELEASE_ID/README.txt

echo 'Edit release notes and exit editor when finished.'

$EDITOR deploy/picard-tools/$RELEASE_ID/README.txt

cp dist/picard-tools-$RELEASE_ID.zip deploy/picard-tools/$RELEASE_ID/

# Make all files to be pushed to Sourceforge writable by group so that another Picard admin can overwrite them.

chmod -R gu+rw javadoc deploy dist

find javadoc deploy dist -type d -exec chmod g+s '{}' ';' 

# Move the javadoc directory to a temporary location
mv javadoc tmp_javadoc

# Copy over javadoc for htsjdk since we are in the picard directory
# NB: need to move javadoc to a tmp directory since the javadoc 
# directory in the gh-pages branch may already exist.
cd htsjdk
mkdir tmp_javadoc
cp -r ../tmp_javadoc/htsjdk tmp_javadoc/.
cd ../

# Update the javadoc
for sandbox in . htsjdk
do pushd $sandbox
	if [ "." == $sandbox ]; then
		sandbox="picard";
	fi
	echo "Updating the javadoc for $sandbox"
	# Checkout the gh-pages branch
	git checkout -b $GHPAGES_BRANCH $REMOTE/$GHPAGES_BRANCH
	# Copy over from the tmp javadoc directory
	if [ ! -d javadoc ]; then
		mkdir javadoc;
	fi
	rsync -avP --delete-after tmp_javadoc/* javadoc/.
	# Remove the tmp directory as we no longer need it
	rm -r tmp_javadoc
	# Add the new javadoc files
	find javadoc/$sandbox | xargs git add
	# Commit!
	git commit -a --allow-empty -m "Updating javadoc for release: $RELEASE_ID"
	# NB: assumes the push will not fail
	git push $REMOTE $GHPAGES_BRANCH
	# Reset the repository to master 
	git checkout master
	echo "Updated the javadoc for $sandbox"
	popd
done

# Publish a release and upload assets
echo "Creating a release on github for htsjdk and picard"
create_release $GITHUB_USER_TOKEN samtools htsjdk $RELEASE_ID "" $RELEASE_ID "Release $RELEASE_ID" "false" "false";
create_release $GITHUB_USER_TOKEN broadinstitute picard $RELEASE_ID "" $RELEASE_ID "Release $RELEASE_ID" "false" "false";
echo "Github release id: $RELEASE_GITHUB_ID"
echo "Updating the release zip and README.txt to github"
upload_asset $GITHUB_USER_TOKEN broadinstitute picard picard-tools-$RELEASE_ID.zip "application/zip" deploy/picard-tools/$RELEASE_ID/picard-tools-$RELEASE_ID.zip $RELEASE_GITHUB_ID;
upload_asset $GITHUB_USER_TOKEN broadinstitute picard README.txt "application/zip" deploy/picard-tools/$RELEASE_ID/README.txt $RELEASE_GITHUB_ID;

# Update the website
echo "Updating the website"
# Assumes the gh-pages branch is already locally created
git checkout $GHPAGES_BRANCH;
cd dist/html
cp inc/*.html program_usage/*.html picard-metric-definitions.html ../../_includes/.
cd ../../
find _includes | xargs git add
git commit -a --allow-empty -m "Adding website files for $RELEASE_ID"
git push $REMOTE $GHPAGES_BRANCH

# Move back to master just in case
git checkout master

echo "Release was successful!"

#!/usr/bin/env bash

# This script is used to build and deploy the GCR docker image for Picard
# The dockerhub image is built using a dockerhub automated build: https://hub.docker.com/r/broadinstitute/picard/builds

if [[ "$1" == "" ]]
then
    echo "Usage: build_push_docker.sh <git-tag>"
    exit 1
fi

declare -r TAG=${1}

declare -r PICARD_CLOUD_TAG=us.gcr.io/broad-gotc-prod/picard-cloud:${TAG}

echo "Will build and push the following docker images:"
echo ${PICARD_CLOUD_TAG}

read -p "Is this really what you want to do? " -n 1 -r
echo    # (optional) move to a new line
if [[ $REPLY =~ ^[Yy]$ ]]
then
    docker build -t ${PICARD_CLOUD_TAG} --build-arg build_command=cloudJar --build-arg jar_name=picardcloud.jar .
    docker push ${PICARD_CLOUD_TAG}
fi

#!/usr/bin/env bash

# Example Usage: ./docker_helper.sh -j "-XX:GCTimeLimit=50 -XX:GCHeapFreeLimit=10 -Xmx4000m" MarkDuplicates INPUT=fake.bam ...
usage() {
  cat << EOF
Usage: $0 [-j <JVM arguments>] tool_name tool_arguments

Run Picard with JVM args and program args if present. Assumes picard.jar lives in the same directory.
JVM arguments should be a quoted, space separated list.

Example Usage:
./docker_helper.sh -j "-XX:GCTimeLimit=50 -XX:GCHeapFreeLimit=10 -Xmx4000m" MarkDuplicates INPUT=fake.bam ...

EOF
  exit 1
}
while getopts "j:h" OPTION; do
  case $OPTION in
    j) JVM_ARGS=$OPTARG;;
    h) usage; exit 0;;
    [?]) usage; exit 1;;
  esac
done
shift $(expr $OPTIND - 1)
TOOL_WITH_ARGS=$@

java ${JVM_ARGS} -jar /usr/picard/picard.jar ${TOOL_WITH_ARGS}

#! /bin/bash
#
# The MIT License
#
# Copyright (c) 2013 The Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

# Build libIntelDeflater.so, the JNI library that wraps Intel IPP compression library.
# Note that this is not built as part of standard release process.  Rather, it is built manually and then
# copied to Picard-public/lib/jni.

# Assumes OpenJDK exists at $OPENJDK.  I used openjdk-7-fcs-src-b147-27_jun_2011.zip
# Assumes that Picard-public java sources have been compiled
# Assumes IPP8_CODE_SAMPLES_DIR points to Intel IPP sample code built with -fPIC
set -e

if [ "$OPENJDK" = "" ]
then echo "ERROR: OPENJDK environment variable not defined." >&2
     exit 1
fi

if [ "$IPP8_CODE_SAMPLES_DIR" = "" ]
then echo "ERROR: IPP8_CODE_SAMPLES_DIR environment variable not defined." >&2
     exit 1
fi

rootdir=$(dirname $(dirname $(dirname $0)))


builddir=$rootdir/lib_build
rm -rf $builddir
mkdir -p $builddir

# Create JNI C header file
javah -jni -classpath $rootdir/classes -d $builddir net.sf.samtools.util.zip.IntelDeflater

# Compile source and create library.
gcc -I$builddir -I$JAVA_HOME/include/ -I$JAVA_HOME/include/linux/ -I$OPENJDK/jdk/src/share/native/common/ \
-I$OPENJDK/jdk/src/solaris/native/common/ -c -O3 -fPIC IntelDeflater.c
gcc  -shared -o $builddir/libIntelDeflater.so IntelDeflater.o  -L${IPP8_CODE_SAMPLES_DIR}/__cmake/data-compression.intel64.make.static.release/__lib/release \
-lzlib  -lstdc++ -Wl,-Bstatic  -lbfp754  -ldecimal  -liomp5  -liompstubs5  -lipgo  -lippac  -lippcc  -lippch  -lippcv  \
-lippdc  -lippdi  -lippgen  -lippi  -lippj  -lippm  -lippr  -lippsc  -lippvc  -lippvm  -lirng  -lmatmul  -lpdbx  \
-lpdbxinst  -lsvml  -lipps  -limf  -lirc  -lirc_s  -lippcore -Wl,-Bdynamic

### Description

_Give your PR a **concise** yet **descriptive** title_
_Please explain the changes you made here._
_Explain the **motivation** for making this change. What existing problem does the pull request solve?_
_Mention any issues fixed, addressed or otherwise related to this pull request, including issue numbers or hard links for issues in other repos._
_You can delete these instructions once you have written your PR description._

----

### Checklist (never delete this)

Never delete this, it is our record that procedure was followed. If you find that for whatever reason one of the checklist points doesn't apply to your PR, you can leave it unchecked but please add an explanation below.

#### Content
- [ ] Added or modified tests to cover changes and any new functionality
- [ ] Edited the README / documentation (if applicable)
- [ ] All tests passing on Travis

#### Review
- [ ] Final thumbs-up from reviewer
- [ ] Rebase, squash and reword as applicable

For more detailed guidelines, see https://github.com/broadinstitute/picard/wiki/Guidelines-for-pull-requests

### Description

_Give your PR a **concise** yet **descriptive** title_
_Please explain the changes you made here._
_Explain the **motivation** for making this change. What existing problem does the pull request solve?_
_Mention any issues fixed, addressed or otherwise related to this pull request, including issue numbers or hard links for issues in other repos._
_You can delete these instructions once you have written your PR description._

----

### Checklist (never delete this)

Never delete this, it is our record that procedure was followed. If you find that for whatever reason one of the checklist points doesn't apply to your PR, you can leave it unchecked but please add an explanation below.

#### Content
- [ ] Added or modified tests to cover changes and any new functionality
- [ ] Edited the README / documentation (if applicable)
- [ ] All tests passing on github actions

#### Review
- [ ] Final thumbs-up from reviewer
- [ ] Rebase, squash and reword as applicable

For more detailed guidelines, see https://github.com/broadinstitute/picard/wiki/Guidelines-for-pull-requests

### Instructions

- Use a **concise** yet **descriptive** title;
- Determine whether your issue is a **bug report**, a **feature request**, or a **documentation request**;
- Choose the corresponding template block below and fill it in, replacing or deleting text in italics (surrounded by `_`) as appropriate;
- Delete the other template blocks and this header.

----

## Bug Report

### Affected tool(s)
_Tool name(s), special parameters?_

### Affected version(s)
- [ ] Latest public release version [version?]
- [ ] Latest development/master branch as of [date of test?]

### Description 
_Describe the problem below. Provide **screenshots** , **stacktrace** , **logs** where appropriate._

#### Steps to reproduce
_Tell us how to reproduce this issue. If possible, include command lines that reproduce the problem and provide a minimal test case._

#### Expected behavior
_Tell us what should happen_

#### Actual behavior
_Tell us what happens instead_

----

## Feature request

### Tool(s) involved
_Tool name(s), special parameters?_

### Description
_Specify whether you want a modification of an existing behavior or addition of a new capability._
_Provide **examples**, **screenshots**, where appropriate._

----

## Documentation request

### Tool(s) involved
_Tool name(s), parameters?_

### Description 
_Describe what needs to be added or modified._

----

## ***This issue tracker is for bug reports only. Before opening a new issue here, please make a post on our [support forum](https://gatk.broadinstitute.org/hc/en-us/community/topics) so that our support team can look at your issue and determine whether it needs to be escalated into a bug report.***

----

### Instructions

- Use a **concise** yet **descriptive** title;
- Determine whether your issue is a **bug report**, a **feature request**, or a **documentation request**;
- Choose the corresponding template block below and fill it in, replacing or deleting text in italics (surrounded by `_`) as appropriate;
- Delete the other template blocks and this header.

----

## Bug Report

### Affected tool(s)
_Tool name(s), special parameters?_

### Affected version(s)
- [ ] Latest public release version [version?]
- [ ] Latest development/master branch as of [date of test?]

### Description 
_Describe the problem below. Provide **screenshots** , **stacktrace** , **logs** where appropriate._

#### Steps to reproduce
_Tell us how to reproduce this issue. If possible, include command lines that reproduce the problem and provide a minimal test case._

#### Expected behavior
_Tell us what should happen_

#### Actual behavior
_Tell us what happens instead_

----

## Feature request

### Tool(s) involved
_Tool name(s), special parameters?_

### Description
_Specify whether you want a modification of an existing behavior or addition of a new capability._
_Provide **examples**, **screenshots**, where appropriate._

----

## Documentation request

### Tool(s) involved
_Tool name(s), parameters?_

### Description 
_Describe what needs to be added or modified._

----
